# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    print("Downloading/Updating package content from upstream binary sources")

    # Initializing variables
    proxies = get_proxies()
    app_name = control.name
    url = control.sources
    bin_name_string = "EZCastPro_Win%s.exe"

    # Getting latest version from official website
    print("URL used is: " + url)
    version = bs_find(url, "a", "href", "javascript:void(0);", proxies=proxies)["onclick"].split("EZCastPro_Win")[-1].split(".exe")[0]
    latest_bin = bin_name_string % version
    url_dl = "http://www.ezcast.com/upgrade/ezcastpro/%s" % latest_bin

    print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin)
        if version != version_from_file:
            os.rename(latest_bin, bin_name_string % version_from_file)
            version = version_from_file

        # Changing version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
        control.save_control_to_wapt()
        print("Changing version to: %s in WAPT\\control" % control.version)

    # Deleting outdated binaries
    remove_outdated_binaries(version)
